#!/bin/bash

cp ./normal.c.bckp ./normal.c
cp ./assign.c.bckp ./assign.c

max=16
sum_cn=0
sum_ca=0
sum_rn=0
sum_ra=0

for ((x=0; x < ${max}; x++)); do
  echo ' ' >> normal.c
  t_tmps="$(date +%s.%N)"
  gcc normal.c -o normal
  t_tmpe="$(date +%s.%N)"
  ta_compn[$x]=`echo "scale=6; ${t_tmpe} - ${t_tmps}" | bc`

  t_tmps="$(date +%s.%N)"
  ./normal 18123
  t_tmpe="$(date +%s.%N)"
  ta_runn[$x]=`echo "scale=6; ${t_tmpe} - ${t_tmps}" | bc`

  sum_cn=`echo "scale=8; ${sum_cn} + ${ta_compn[$x]}" | bc`
  sum_rn=`echo "scale=8; ${sum_rn} + ${ta_runn[$x]}" | bc`
done

for ((x=0; x < ${max}; x++)); do
  echo ' ' >> assign.c
  t_tmps="$(date +%s.%N)"
  gcc assign.c -o assign 
  t_tmpe="$(date +%s.%N)"
  ta_compa[$x]=`echo "scale=6; ${t_tmpe} - ${t_tmps}" | bc`

  t_tmps="$(date +%s.%N)"
  ./assign 18123
  t_tmpe="$(date +%s.%N)"
  ta_runa[$x]=`echo "scale=6; ${t_tmpe} - ${t_tmps}" | bc`

  sum_ca=`echo "scale=8; ${sum_ca} + ${ta_compa[$x]}" | bc`
  sum_ra=`echo "scale=8; ${sum_ra} + ${ta_runa[$x]}" | bc`
done

avg_cn=`echo "scale=6; ${sum_cn} / ${max}" | bc`
avg_rn=`echo "scale=6; ${sum_rn} / ${max}" | bc`
avg_ca=`echo "scale=6; ${sum_ca} / ${max}" | bc`
avg_ra=`echo "scale=6; ${sum_ra} / ${max}" | bc`

echo -e "\nResults:"
printf " Normal {}, compile: %8.6f; run: %8.6f\n" ${avg_cn} ${avg_rn}
printf " Assign [], compile: %8.6f; run: %8.6f\n" ${avg_ca} ${avg_ra}
echo "Binary file size:" 
ls -lh ./normal
ls -lh ./assign
echo -e "\n"
